#include <stdio.h>
#include <math.h>
#include <avs/flow.h> 
#include <avs/avs_data.h>
#include <avs/field.h>

static FILE *fp = NULL;
#define Default_fname "model.out"
#define Module_name "model_out_SUN"

AVSinit_modules()
{
  int merge();

  AVSmodule_from_desc(merge);
}

/*  The routine "merge" is the description routine.  */
merge()
{
  int merge_compute();	 /* declare the compute function (below) */
  int in_port;           /* temporary to hold the port number */
  int parm;		 /* temporary to hold the parm number */

  /* Set the module name and type */
  AVSset_module_name(Module_name, MODULE_MAPPER);
  
  /* Create an input port for the required field input */
  in_port = AVScreate_input_port("Bias", "real",REQUIRED);
  /* Create output ports for the result */

  /* Add parameter:  */
  parm = AVSadd_parameter("Output Model Result Browser", "string", Default_fname, 0, 0);
  AVSconnect_widget(parm,"browser");
  
  /* Tell avs what subroutine to call to do the compute */
  AVSset_compute_proc(merge_compute);
}

/*  merge_compute is the compute routine.  */
merge_compute(bias,OutFileName)
char *OutFileName;
float *bias;
{
  if (AVSparameter_changed("Output Model Result Browser")||(fp == NULL)) {
    fprintf(stderr,"open file %s\n",OutFileName);
    if (fp != NULL) fclose(fp);
    if ((fp = fopen(OutFileName, "w")) == NULL) {
      AVSerror("finance_out: cannot open %s\n",OutFileName);
      return(1);
    }
    fprintf(fp,"Model bias\n");
  }
  fprintf(fp,"%8.5f\n",*bias);

  /* When we're done, we return 1 to indicate success */
  return(1);
}

